# punctilious

<br />
<div align="center">
  <a href="https://github.com/daviddoret/punctilious">
    <img src="branding/punctilious-logo-full-light-600x600-white.png" alt="Logo" width="300" height="300">
  </a>
</div>
<p align="center">
    A human-friendly and developer-friendly math proof assistant library.
</p>

## About

*Punctilious* is a *math proof assistant* open-source project developed in python. In straightforward language, it
intends to
facilitate the study and development of mathematical proofs by human beings.

There exists multiple math proof assistants, including:

* [Coq](https://coq.inria.fr/)
* [Isabelle](https://isabelle.in.tum.de/)
* [Lean](https://leanprover.github.io/)

...and many more. The [proof assistant](https://en.wikipedia.org/wiki/Proof_assistant) page on Wikipedia contains a
general-purpose comparison of these.

In contrast, *punctilious* is a ridiculous [Lilliputian](https://en.wikipedia.org/wiki/Lilliput_and_Blefuscu) with
neither the length, nor the breadth of these time-proven systems.

### So why develop yet another math proof assistant?

Besides being a fun and thrilling learning experience, the focus points of *punctilious* are:

* Human-friendly and developer-friendly inputs (i.e.: write math as we learn it)
* Ease of use
* Human-friendly and developer-friendly outputs (i.e.: readable)

*Punctilious* does not pay much attention to:

* Performance (i.e. for large-scale proof applications)

## Prerequisites

Python 3.11

## Installation

We are just in the process of publishing *punctilious* on PyPI. Please wait...

## Getting started

Many samples will be provided soon once we will have published our documentation on ReadTheDocs. Please wait...

## Documentation

*Punctilious* documentation lives on [ReadTheDocs](https://punctilious.readthedocs.io/en/latest/).

## More links

* [Roadmap](https://punctilious.readthedocs.io/en/latest/front_matter/roadmap_front_matter.html)
* [Contributing](https://punctilious.readthedocs.io/en/latest/front_matter/contributing_front_matter.html)
* [Project](https://punctilious.readthedocs.io/en/latest/front_matter/project_front_matter.html)
* [License](https://github.com/daviddoret/punctilious/blob/master/LICENSE)

## Acknowledgments

The list of dependencies is being compiled. Please wait...
